<template>
  <v-row justify="center" no-gutters>
    <v-card class="pa-6" style="width: 100%;" align="center">
      <v-icon
        v-if="!userNotFound"
        style="transform: scale(1.3);"
        class="mb-5"
        color="primary"
        x-large
        >mdi-account-switch-outline</v-icon
      >
      <v-icon v-else style="transform: scale(1.3);" class="mb-5" color="test" x-large
        >mdi-alert</v-icon
      >

      <p>
        <span v-if="!changeRoleDenied && !userNotFound">
          Você deseja <b>alterar</b> o papel do usuário <br /><b
            >{{ user.name }} {{ user.surname }}</b
          >
          para:
        </span>
        <span v-if="changeRoleDenied && !userNotFound"
          >Você<b> não tem permissão</b> para alterar o papel de um <b>{{ actualRole.label }}</b
          >.</span
        >
        <span v-if="userNotFound">
          Esse usuário<b> não possui papel </b> em <b>{{ nameOfEntity }}</b
          >.</span
        >
      </p>
      <v-autocomplete
        v-if="!changeRoleDenied && !userNotFound"
        class="my-3"
        style="width: 70%"
        v-model="userRole"
        label="Selecione um papel"
        solo-inverted
        flat
        hide-no-data
        hide-details
        :items="availableRoles"
        item-text="label"
        item-value="id"
        @change="changeRole"
      ></v-autocomplete>

      <v-btn
        v-if="userNotFound"
        class="mt-4"
        color="primary"
        :style="hover3 && 'padding-left: 17px; padding-right: 17px; color: white'"
        elevation="0"
        :outlined="!hover3"
        @click="handleClose"
        @mouseenter="hover3 = true"
        @mouseleave="hover3 = false"
        >Fechar</v-btn
      >
      <v-btn
        v-if="!userNotFound"
        class="mt-4"
        color="primary"
        :style="hover2 && 'padding-left: 17px; padding-right: 17px; color: white'"
        elevation="0"
        :outlined="!hover2"
        @click="handleClose"
        @mouseenter="hover2 = true"
        @mouseleave="hover2 = false"
        >Cancelar</v-btn
      >
      <v-btn
        v-if="!userNotFound"
        :disabled="newSelectedRole == null || userRole == newSelectedRole"
        class="mt-4 ml-2"
        color="primary"
        :style="hover && 'color: white'"
        elevation="0"
        :outlined="!hover"
        @click="handleChangeRole"
        @mouseover="hover = true"
        @mouseleave="hover = false"
        >Alterar</v-btn
      >
    </v-card>
  </v-row>
</template>

<script>
import Management from '../../services/management'

export default {
  name: 'UserChangeRole',
  props: {
    user: { type: Object },
    actualRole: { type: Object },
    availableRoles: { type: Array },
    changeRoleDenied: { type: Boolean },
    userNotFound: { type: Boolean },
    nameOfEntity: { type: String },
  },
  components: {},
  data: () => ({
    userRole: null,
    newSelectedRole: null,
    hover: false,
    hover2: false,
    hover3: false,
  }),

  beforeUpdate() {
    this.userRole = this.actualRole.id
  },
  created() {
    this.userRole = this.actualRole.id
  },

  methods: {
    handleClose() {
      this.newSelectedRole = null
      this.$emit('closeUserChangeRole')
    },
    changeRole(role) {
      this.newSelectedRole = role
    },
    async handleChangeRole() {
      const routedEntity = await this.$getItem('routedEntity')
      const userInfo = await this.$getItem('userInfo')
      const userId = userInfo.id
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('userChangePrivilege').id
      let data = {
        id: this.user.id,
        entity: entityId,
        privilege: this.newSelectedRole,
      }
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Management.changeUserPrivileges(entityId, actionId, data)
        if (ret.success) {
          this.$emit('userChangeRoleDone')
          this.newSelectedRole = null

          //checa se alterou o papel dele mesmo na entidade
          if (userId == this.user.id) this.$emit('updatedHimself')
        } else {
          this.$emit('userChangeRoleFailed')
          this.newSelectedRole = null
        }
      } catch (e) {
        console.log(e)
      } finally {
      }
    },
  },
}
</script>

<style scoped></style>
